%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [Ref_Dir_Origin, Ref_Dir_Vector] = Get_Fast_Coord_X_Direction(Fastener_Index, Head_Layer, Axis_Point_1, Axis_Point_2, Axis_vector)

global ErrCode;

global DB_FASTENERS;

global DB_ELEMENTS;
global DB_PSETS;
global DB_MATERIALS;

global AT_ELEMENTS;
global AT_PSETS;
global AT_MATERIALS;

Ref_Dir_Origin = [];
Ref_Dir_Vector = [];

% Инициализация флагов
CM_flag = 0;
CM_index = 0;

Metal_flag = 0;
Metal_index = 0;

% Цикл по ярусам
for j=1:DB_FASTENERS{Fastener_Index}.N_layers
    
    % Ветвление по типу присоединенной топологии
    switch DB_FASTENERS{Fastener_Index}.Joint_topology{j}

        case {'plate', 'rbe2_2d_hole', 'bar_spider_2d_hole', 'plate_rbe2_sequential', 'plate_rbe2_parallel'}

            pset_type = DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{j}.Element_list(1))}.Prop_ID)}.type;

            switch pset_type

                case {'PCOMP', 'PCOMPG'}
                    
                    if (CM_flag == 0)
                        CM_flag = 1;
                        CM_index = j;
                    end

                case 'PSHELL'

                    % Проверка типа материала
                    mat_type = DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{j}.Element_list(1))}.Prop_ID)}.Mat_ID_membrane)}.type;

                    switch mat_type
                        case 'isotropic'
                            if (Metal_flag == 0)
                                Metal_flag = 1;
                                Metal_index = j;
                            end
                        case '2d_orthotropic'
                            if (CM_flag == 0)
                                CM_flag = 1;
                                CM_index = j;
                            end
                        case '2d_anisotropic'
                            if (CM_flag == 0)
                                CM_flag = 1;
                                CM_index = j;
                            end
                        otherwise
                            fprintf (1, '\nОшибка функции Get_Fast_Coord_X_Direction: недопустимый тип материала [%s] среди элементов присоединенной топологии [%s] болта %i !\n', mat_type, DB_FASTENERS{Fastener_Index}.Joint_topology{j}, Fastener_Index);
                            ErrCode = -1;
                            return;
                    end

                otherwise

                    fprintf (1, '\nОшибка функции Get_Fast_Coord_X_Direction: недопустимый тип property set [%s] среди элементов присоединенной топологии [%s] болта %i !\n', pset_type, DB_FASTENERS{Fastener_Index}.Joint_topology{j}, Fastener_Index);
                    ErrCode = -1;
                    return;

            end

        case {'rbe2_3d_hole', 'bar_spider_3d_hole'}

            % Ничего не делаем

        otherwise

            fprintf (1, '\nОшибка функции Get_Fast_Coord_X_Direction: неизвестный тип присоединенной топологии [%s] в болте %i !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{j}, Fastener_Index);
            ErrCode = -1;
            return;

    end
    
end

% Если есть пластина из композита, то берем ориентацию композита
if (CM_flag == 1)
    
    Ref_Dir_Origin = Get_Plate_Midsurf_Point(Fastener_Index, CM_index, Axis_Point_1, Axis_Point_2, Axis_vector);

    if (ErrCode < 0)
        return;
    end
    
    Ref_Dir_Vector = Get_Plate_Orientation(Fastener_Index, CM_index);

    if (ErrCode < 0)
        return;
    end
    
    Ref_Dir_Vector = Ref_Dir_Vector - dot(Ref_Dir_Vector, Axis_vector) * Axis_vector;
    Ref_Dir_Vector = Ref_Dir_Vector / norm(Ref_Dir_Vector);
    
    return;
    
end

% Если есть пластина из металла, то берем направление ориентации первого элемента (в общем случае это вектор от первого узла ко второму)
if (Metal_flag == 1)
    
    Ref_Dir_Origin = Get_Plate_Midsurf_Point(Fastener_Index, Metal_index, Axis_Point_1, Axis_Point_2, Axis_vector);

    if (ErrCode < 0)
        return;
    end
    
    Ref_Dir_Vector = Get_Shell_Orientation_Vector(DB_FASTENERS{Fastener_Index}.Joint_mesh{Metal_index}.Element_list(1));
    
    Ref_Dir_Vector = Ref_Dir_Vector - dot(Ref_Dir_Vector, Axis_vector) * Axis_vector;
    Ref_Dir_Vector = Ref_Dir_Vector / norm(Ref_Dir_Vector);
    
    return;
    
end

% Если предыдущие флаги не сработали, то значит всех ярусах 3D отверстия. В этом случае берем референсное направление яруса со стороны головки болта
[Ref_Dir_Origin, Ref_Dir_Vector] = Get_Reference_Direction(Fastener_Index, Head_Layer, Axis_Point_1, Axis_Point_2, Axis_vector);

if (ErrCode < 0)
    return;
end
